proc tac_cmd_clear {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9]+)$} $line match cmd exc]} {
        set len 50
    } else {
        set len $exc
    }

    for {set i 0} {$i < $len} {incr i} {
        tac_output ""
    }
}

proc tac_cmd_ver {exp line} {
    tac_output "Client Version: $::VERSION"

    if {[lsearch [package names] http] != -1} {
        set tokn [::http::geturl "http://users.tmok.com/~smike/ver"]
        upvar #0 $tokn state
        tac_output "Newest Version: $state(body)"
    }
}

proc tac_cmd_shell {exp line} {
    if {![regexp -- {^(\!) (.*)$} $line match cmd exc]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

#    tac_output $exc
    catch {tac_output [exec "$exc"]}
}

proc tac_cmd_date {exp line} {
    if { $::TAC(time12) == 12 } {
        tac_output [clock format [clock seconds] -format "%A %B %d, %Y %I:%M:%S %p"]
    } else {
        tac_output [clock format [clock seconds] -format "%A %B %d, %Y %H:%M:%S"]
    }
}

tac_register_cmd 0 "o" "^\! "       tac_cmd_shell          "  ! command        execute shell command"

tac_register_cmd 1 "o" "^/v$"       tac_cmd_ver            "  /v               show the current Tac version"
tac_register_cmd 1 "o" "^/date$"    tac_cmd_date           "  /date            print the current date & time."
tac_register_cmd 1 "o" "^/clr "     tac_cmd_clear          "  /clr {n}         clear screen (default 50 blank lines)"
tac_register_cmd 1 "o" "^/clr$"     tac_cmd_clear

tac_register_cmd 2 "o" "^o:v$"      tac_cmd_ver            "  o:v              show the current Tac version"
tac_register_cmd 2 "o" "^o:d$"      tac_cmd_date           "  o:d              print the current date & time."
tac_register_cmd 2 "o" "^o:c "      tac_cmd_clear          "  o:c {n}          clear screen (default 50 blank lines)"
tac_register_cmd 2 "o" "^o:c$"      tac_cmd_clear
tac_register_cmd 2 "o" "^o:h$"      tac_cmd_help
